Integration with Editor
This guide will show you how to integrate an external Editor into Grid for data editing.
Setting up the Editor fields
To assign fields to the external editor, use the getEditorConfig helper function. This helper will generate the editor configuration for each column based on the column definitions you specify in Grid. You should define a control type within the same column setting (editor) that is used for built-in editors.
<script setup>
import { Grid, getEditorConfig } from "@svar-ui/vue-grid";
import { Editor } from "@svar-ui/vue-editor";
const columns = [
{ id: "id", width: 50 },
{
id: "firstName",
header: "Name",
editor: "text", //Editor control that will be used for this field
width: 160,
},
{
id: "country",
header: "Country",
editor: "richselect",
options: countries,
width: 160,
},
];
const items = getEditorConfig(columns);
const dataToEdit = ref(null);
</script>
<template>
<Grid :data="data" :columns="columns" />
<Editor v-if="dataToEdit" :values="dataToEdit" :items="items" />
</template>
Registering custom editor types
Editor provides built-in controls like "text", "checkbox", "textarea" that do not require additional setup. You just need to define them in the editor field of the columns array. For custom editor types (e.g., datepicker, richselect), you need to import the registerEditorItem from Editor and register the required editor type.
import { DatePicker, RichSelect } from "@svar-ui/vue-core";
import { Editor, registerEditorItem } from "@svar-ui/vue-editor";
// Register custom editor types
registerEditorItem("richselect", RichSelect);
registerEditorItem("datepicker", DatePicker);
Opening and closing Editor
Since editor fields are defined on the column level, you need to intercept default behaviour (opening an inline editor) and show Editor instead.
<script setup>
import { ref } from "vue";
import { Grid, getEditorConfig } from "@svar-ui/vue-grid";
import { Editor } from "@svar-ui/vue-editor";
const init = api => {
api.intercept("open-editor", ({ id }) => {
dataToEdit.value = api.getRow(id); // Retrieve data for the selected row
return false; // Prevent the default editor from opening
});
}
const items = getEditorConfig(columns);
const dataToEdit = ref(null);
</script>
<template>
<Grid :data="data" :columns="columns" :init="init"/>
<Editor v-if="dataToEdit" :values="dataToEdit" :items="items" />
</template>
You can also update the Editor field when it's open using the select-row action:
- Listen for the
select-rowaction via theapi.on()method to capture the row data whenever a new row is selected. - Ensure that if Editor is already open (
dataToEditis not null), it gets updated with the newly selected row data.
// Intercept the open-editor action and store data to be edited
api.intercept("open-editor", ({ id }) => {
dataToEdit.value = api.getRow(id);
return false;
});
// Handle row selection and update editor if it's open
api.on("select-row", ({ id }) => {
if (dataToEdit.value) {
dataToEdit.value = id ? api.getRow(id) : null; // Update editor data or reset
}
});
To handle the click on the "close" icon in Editor and close it (by resetting the dataToEdit), you can use the onaction event.
<template>
<Editor
:onaction="({ item }) => {
if (item.icon) dataToEdit = null;
}"
/>
</template>
Saving changes to Grid
When editing data in Editor, you need to use the appropriate events to update the Grid data. The event you subscribe to depends on the autoSave settings:
-
If
autoSaveis true, changes are saved automatically as you edit individual fields. In this case, use theonchangeevent (fires when a single field is updated) to update the corresponding cell in Grid viaupdate-cell. -
If
autoSaveis false, changes are saved only when the user clicks the "Save" button. In this case, use theonsaveevent (fires when the entire form is saved) to update the entire row in Grid viaupdate-row.
<script setup>
import { ref } from "vue";
import { Grid, getEditorConfig } from "@svar-ui/vue-grid";
import { Editor } from "@svar-ui/vue-editor";
const api = ref();
</script>
<template>
<Editor
:values="dataToEdit"
:items="getEditorConfig(columns)"
placement="sidebar"
:autoSave="true"
:onchange="({ key, value }) => {
api.exec('update-cell', { // Update individual cell data
id: dataToEdit.id,
column: key,
value,
});
}"
:onsave="({ values }) => {
api.exec('update-row', { // Update the entire row
id: dataToEdit.id,
row: values,
});
}"
/>
<Grid :data="data" :columns="columns" ref="api"/>
</template>
Related samples:
Related articles:

Integration with Editor
This guide will show you how to integrate an external Editor into Grid for data editing.
Setting up the Editor fields
To assign fields to the external editor, use the getEditorConfig helper function. This helper will generate the editor configuration for each column based on the column definitions you specify in Grid. You should define a control type within the same column setting (editor) that is used for built-in editors.
<script>
import { Grid, getEditorConfig } from "@svar-ui/svelte-grid";
import { Editor } from "@svar-ui/svelte-editor";
const columns = [
{ id: "id", width: 50 },
{
id: "firstName",
header: "Name",
editor: "text", //Editor control that will be used for this field
width: 160,
},
{
id: "country",
header: "Country",
editor: "richselect",
options: countries,
width: 160,
},
];
const items = getEditorConfig(columns);
let dataToEdit = $state(null);
</script>
<Grid {data} {columns} />
{#if dataToEdit}
<Editor values={dataToEdit} {items} />
{/if}
Registering custom editor types
Editor provides built-in controls like "text", "checkbox", "textarea" that do not require additional setup. You just need to define them in the editor field of the columns array. For custom editor types (e.g., datepicker, richselect), you need to import the registerEditorItem from Editor and register the required editor type.
import { DatePicker, RichSelect } from "@svar-ui/svelte-core";
import { Editor, registerEditorItem } from "@svar-ui/svelte-editor";
// Register custom editor types
registerEditorItem("richselect", RichSelect);
registerEditorItem("datepicker", DatePicker);
Opening and closing Editor
Since editor fields are defined on the column level, you need to intercept default behaviour (opening an inline editor) and show Editor instead.
<script>
import { Grid, getEditorConfig } from "@svar-ui/svelte-grid";
import { Editor } from "@svar-ui/svelte-editor";
const init = api => {
api.intercept("open-editor", ({ id }) => {
dataToEdit = api.getRow(id); // Retrieve data for the selected row
return false; // Prevent the default editor from opening
});
}
const items = getEditorConfig(columns);
let dataToEdit = $state(null);
</script>
<Grid {data} {columns} {init}/>
{#if dataToEdit}
<Editor values={dataToEdit} {items} />
{/if}
You can also update the Editor field when it's open using the select-row action:
- Listen for the
select-rowaction via theapi.on()method to capture the row data whenever a new row is selected. - Ensure that if Editor is already open (
dataToEditis not null), it gets updated with the newly selected row data.
// Intercept the open-editor action and store data to be edited
api.intercept("open-editor", ({ id }) => {
dataToEdit = api.getRow(id);
return false;
});
// Handle row selection and update editor if it's open
api.on("select-row", ({ id }) => {
if (dataToEdit) {
dataToEdit = id ? api.getRow(id) : null; // Update editor data or reset
}
});
To handle the click on the "close" icon in Editor and close it (by resetting the dataToEdit), you can use the onaction event.
<Editor
onaction={({ item }) => {
if (item.icon) dataToEdit = null;
}}
/>
Saving changes to Grid
When editing data in Editor, you need to use the appropriate events to update the Grid data. The event you subscribe to depends on the autoSave settings:
-
If
autoSaveis true, changes are saved automatically as you edit individual fields. In this case, use theonchangeevent (fires when a single field is updated) to update the corresponding cell in Grid viaupdate-cell. -
If
autoSaveis false, changes are saved only when the user clicks the "Save" button. In this case, use theonsaveevent (fires when the entire form is saved) to update the entire row in Grid viaupdate-row.
<script>
import { Grid, getEditorConfig } from "@svar-ui/svelte-grid";
import { Editor } from "@svar-ui/svelte-editor";
let api = $state();
</script>
<Editor
values={dataToEdit}
items={getEditorConfig(columns)}
placement="sidebar"
autoSave={true}
onchange={({ key, value }) => {
api.exec("update-cell", { // Update individual cell data
id: dataToEdit.id,
column: key,
value,
});
}}
onsave={({ values }) => {
api.exec("update-row", { // Update the entire row
id: dataToEdit.id,
row: values,
});
}}
/>
<Grid {data} {columns} bind:this={api}/>
Related samples:
Related articles:

Integration with Editor
This guide will show you how to integrate an external Editor into Grid for data editing.
Setting up the Editor fields
To assign fields to the external editor, use the getEditorConfig helper function. This helper will generate the editor configuration for each column based on the column definitions you specify in Grid. You should define a control type within the same column setting (editor) that is used for built-in editors.
import { useState } from "react";
import { Grid, getEditorConfig } from "@svar-ui/react-grid";
import { Editor } from "@svar-ui/react-editor";
const columns = [
  { id: "id", width: 50 },
  {
    id: "firstName",
    header: "Name",
    editor: "text", // Editor control that will be used for this field
    width: 160,
  },
  {
    id: "country",
    header: "Country",
    editor: "richselect",
    options: countries,
    width: 160,
  },
];
const items = getEditorConfig(columns);
export default function Example({ data }) {
  const [dataToEdit, setDataToEdit] = useState(null);
  return (
    <>
      <Grid data={data} columns={columns} />
      {dataToEdit && <Editor values={dataToEdit} items={items} />}
    </>
  );
}
Registering custom editor types
Editor provides built-in controls like "text", "checkbox", "textarea" that do not require additional setup. You just need to define them in the editor field of the columns array. For custom editor types (e.g., datepicker, richselect), you need to import the registerEditorItem from Editor and register the required editor type.
import { DatePicker, RichSelect } from "@svar-ui/react-core";
import { Editor, registerEditorItem } from "@svar-ui/react-editor";
// Register custom editor types
registerEditorItem("richselect", RichSelect);
registerEditorItem("datepicker", DatePicker);
Opening and closing Editor
Since editor fields are defined on the column level, you need to intercept default behaviour (opening an inline editor) and show Editor instead.
import { useState } from "react";
import { Grid, getEditorConfig } from "@svar-ui/react-grid";
import { Editor } from "@svar-ui/react-editor";
const items = getEditorConfig(columns);
export default function Example({ data }) {
  const [dataToEdit, setDataToEdit] = useState(null);
  const init = (api) => {
    api.intercept("open-editor", ({ id }) => {
      setDataToEdit(api.getRow(id)); // Retrieve data for the selected row
      return false; // Prevent the default editor from opening
    });
  };
  return (
    <>
      <Grid data={data} columns={columns} init={init} />
      {dataToEdit && <Editor values={dataToEdit} items={items} />}
    </>
  );
}
You can also update the Editor field when it's open using the select-row action:
- Listen for the 
select-rowaction via theapi.on()method to capture the row data whenever a new row is selected. - Ensure that if Editor is already open (
dataToEditis not null), it gets updated with the newly selected row data. 
// Intercept the open-editor action and store data to be edited
api.intercept("open-editor", ({ id }) => {
  setDataToEdit(api.getRow(id));
  return false;
});
// Handle row selection and update editor if it's open
api.on("select-row", ({ id }) => {
  if (dataToEdit) {
    setDataToEdit(id ? api.getRow(id) : null); // Update editor data or reset
  }
});
To handle the click on the "close" icon in Editor and close it (by resetting the dataToEdit), you can use the onAction event.
<Editor
  onAction={({ item }) => {
    if (item.icon) setDataToEdit(null);
  }}
/>
Saving changes to Grid
When editing data in Editor, you need to use the appropriate events to update the Grid data. The event you subscribe to depends on the autoSave settings:
- 
If
autoSaveis true, changes are saved automatically as you edit individual fields. In this case, use theonChangeevent (fires when a single field is updated) to update the corresponding cell in Grid viaupdate-cell. - 
If
autoSaveis false, changes are saved only when the user clicks the "Save" button. In this case, use theonSaveevent (fires when the entire form is saved) to update the entire row in Grid viaupdate-row. 
import { useRef } from "react";
import { Grid, getEditorConfig } from "@svar-ui/react-grid";
import { Editor } from "@svar-ui/react-editor";
export default function Example({ data }) {
  const apiRef = useRef(null);
  return (
    <>
      <Editor
        values={dataToEdit}
        items={getEditorConfig(columns)}
        placement="sidebar"
        autoSave={true}
        onChange={({ key, value }) => {
          apiRef.current.exec("update-cell", {
            id: dataToEdit.id,
            column: key,
            value,
          });
        }}
        onSave={({ values }) => {
          apiRef.current.exec("update-row", {
            id: dataToEdit.id,
            row: values,
          });
        }}
      />
      <Grid data={data} columns={columns} ref={apiRef} />
    </>
  );
}
Related articles: